/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooGetProfileDir(){
	try{
		var prefd = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
		prefd = prefd.get('PrefD', Components.interfaces.nsILocalFile);
		return prefd;
	}catch(e){
		throw 'ERROR fetching profile directory: '+ e;
	}
}
function yahooGetCacheDir(){
	var prefd = null
	try {
		var prefd = yahooGetProfileDir();
		var extd = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
			extd.initWithFile(prefd);
			extd.appendRelativePath("extensions");
			extd.appendRelativePath("{635abd67-4fe9-1b23-4f01-e679fa7484c1}");
		if(!extd.exists()){
			extd.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 0777);
		}
		extd.appendRelativePath("cache");
		if(!extd.exists()){
			extd.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 0777);
		}
		return extd;
	} catch(e) {
		if(prefd != null)
			return prefd;		
		throw 'ERROR fetching cache directory: '+e;
	}
	return prefd;
}
function yahooGetCacheFile(fileName) {
	try {
		var file = yahooGetCacheDir();
		file.appendRelativePath(fileName);
	} catch(e) {
		throw 'ERROR fetching datafile '+fileName+': '+e;
	}
	return file;
}
function yahooReadFile(file){
	var fileContents = "";
	try{
		if(!file.exists()){
			return null;
		}
		var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		inputStream.init(file, 0x01, 0666, 0);
		var fileHandle = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		fileHandle.init(inputStream);
		var size = 0;
		while(size = inputStream.available()) {
			fileContents += fileHandle.read(size);
		}
		fileHandle.close();
	}catch(e){
		throw 'ERROR reading file: '+e;
	}
	return fileContents;
}
function yahooReadCacheFile(fileName) {
	try {
		var file = yahooGetCacheFile(fileName);
		return yahooReadFile(file);
	} catch(e) {
		throw 'ERROR reading cache file '+fileName+': '+e;
	}
	return null;
}
function yahooWriteCacheFile(fileName, fileContents) {
	try {
		var file = yahooGetCacheFile(fileName);
		var fileHandle = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		fileHandle.init(file, 0x04 | 0x08 | 0x20, 0666, 0);
		fileHandle.write(fileContents, fileContents.length);
		fileHandle.flush();
		fileHandle.close();
	} catch(e) {
		throw 'ERROR writing file '+fileName+': '+e;
	}
	return true;
}
function yahooRemoveCacheFile(fileName){
	try{
		var file = yahooGetCacheDir();
		if(fileName != null){
			file.appendRelativePath(fileName);
		}
		if(file.exists()){
			file.remove(true);
		}
	} catch(e){
		throw "ERROR removing cache file ("+ fileName +"): "+ e;
	}
}
function yahooLoadSearchHistory() {
	try{
		var xml = "<?xml version=\"1.0\" encoding=\"utf8\" ?><history></history>";
		var file = yahooGetCacheFile("searchHistory.xml");
		if(!file.exists() || file.fileSize <= 0) {
			yahooWriteCacheFile("searchHistory.xml", xml);
		}
		else{
			xml = yahooReadFile(file);
		}
		var parser = new DOMParser();
		yahooSearchHistory = parser.parseFromString(xml, "text/xml");
		if(yahooSearchHistory.tagName == "parserError"){
			yahooSearchHistory = null;
		}
		else{
			yahooSearchHistory = yahooSearchHistory.firstChild;
		}
	}catch(e){
	}
}
function yahooSaveSearchHistory(){
	try{
		if(yahooSearchHistory.tagName == "parserError"){
			return;
		}
		if(yahooSearchHistory.childNodes.length >= 50){
			for(var i = 50; i < yahooSearchHistory.childNodes.length; i++){
				yahooSearchHistory.removeChild(yahooSearchHistory.childNodes[i]);
			}
		}
		var serializer = new XMLSerializer();
		var xml = serializer.serializeToString(yahooSearchHistory.parentNode);
		yahooWriteCacheFile("searchHistory.xml", xml);
		if(yahooObsSvc != null){
			yahooObsSvc.notifyObservers(null, "yahoo-search-history", "updated");
		}
	} catch(e){
	}
}
