/*
 * Copyright 2005 - 2006 Yahoo! Inc. All rights reserved.
 */
function yahooOptionsInit(){
	try{
		var keypressed = function(event){
			if(event.keyCode == event.DOM_VK_ENTER || event.keyCode == event.DOM_VK_RETURN){
				if(event.originalTarget.tagName != "button" || event.originalTarget.id == "btn-accept"){
					yahooOptionsSave();
				}
			}
		}
		window.addEventListener("keydown", keypressed, true);
		var antispy = yahooGetPref("yahoo.options.antispy");
		var icons = yahooGetPref("yahoo.options.iconsonly");
		var menubar = yahooGetPref("yahoo.options.menubar");
		var showhistory = yahooGetPref("yahoo.options.showhistory");
		var showlivesearch = yahooGetPref("yahoo.options.showlivesearch");
		var livesearchEnabled = yahooGetPref("yahoo.supports.livesearch");
		var searchopt = document.getElementById("show-livesearch");
		var historyopt = document.getElementById("show-history");
		if(showhistory == null)
			showhistory = true;
		if(showlivesearch == null)
			showlivesearch = true;
		if(antispy != null && document.getElementById("btns-antispy") != null){
			document.getElementById("btns-antispy").checked = antispy;
		}
		if(icons != null){
			document.getElementById("icons-only").checked = icons;
		}
		if(menubar != null){
			document.getElementById("menubar-menu").checked = menubar;
		}
		if(historyopt){
			historyopt.checked = showhistory;
		}
		if(searchopt){
			searchopt.checked = showlivesearch;
		}
		if(!livesearchEnabled && searchopt){
			searchopt.setAttribute("hidden", true);
		}
		var ffver = 1.0;
		if(Components.interfaces.nsIXULAppInfo){
			var app = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
			ffver = parseFloat(app.version);
		}
		if(ffver < 1.5){
			if(historyopt){
				historyopt.checked = false;
				historyopt.disabled = true;
			}
			if(searchopt){
				searchopt.checked = false;
				searchopt.disabled = true;
			}	
		}
		if(navigator.platform.toLowerCase().indexOf("win") == -1 && yahooGetPref("yahoo.debug.mac") != true){
			var anti = document.getElementById("btns-antispy")
			anti.checked = false;
			anti.setAttribute("hidden", true);
			document.getElementById("button-options").setAttribute("hidden", true);
		}
	} catch(e){ 
	}
	return true;
}
function yahooOptionsSave(){
	try{
		if(document.getElementById("btns-antispy") != null){
			yahooSetPref("yahoo.options.antispy", document.getElementById("btns-antispy").checked);
		}
		yahooSetPref("yahoo.options.iconsonly", document.getElementById("icons-only").checked);
		yahooSetPref("yahoo.options.menubar", document.getElementById("menubar-menu").checked);
		yahooSetPref("yahoo.options.showhistory", document.getElementById("show-history").checked);
		yahooSetPref("yahoo.options.showlivesearch", document.getElementById("show-livesearch").checked);
	} catch(e){ 
	}
	self.close();
}
function yahooOptionsApply(){
	try{
		var search = document.getElementById("yahooToolbarEditBox");
		var antispy = yahooGetPref("yahoo.options.antispy");
		var icons = yahooGetPref("yahoo.options.iconsonly");
		var menubar = yahooGetPref("yahoo.options.menubar");
		var showhistory = yahooGetPref("yahoo.options.showhistory");
		var showlivesearch = yahooGetPref("yahoo.options.showlivesearch");
		if(navigator.platform.toLowerCase().indexOf("win") == -1 && yahooGetPref("yahoo.debug.mac") != true){
			antispy = false;
			yahooSetPref("yahoo.options.antispy", false);
		}
		if(antispy != null){
			if((asBtn = document.getElementById("yahoo-toolbar-psr1_m")) != null){
				asBtn.setAttribute("hidden", !antispy);
			}
			if((asBtn = document.getElementById("menu_yahoo-toolbar-psr1_m")) != null){
				asBtn.setAttribute("hidden", !antispy);
			}
		}
		yahooToggleIconsAndNames();
		if(menubar != null){
			var item = document.getElementById("yahoo-menubar-item");
			if(item != null){
				item.parentNode.setAttribute("hidden", !menubar);
			}
		}
		if(search){
			if(showhistory == false && showlivesearch == false){
				search.setAttribute("enablehistory", "false");
			}
			else{
				search.setAttribute("enablehistory", "true");
			}
		}
		if(!showhistory){
			yahooClearSearchHistory();
		}
	} catch(e){ 
	}
}
function yahooOptionsHelp(url){
	var sUrl = (typeof(url) != 'undefined') ? url : "http://help.yahoo.com/help/us/toolbar/toolbar-02.html";
	if(opener){
		opener.open(sUrl).focus();
	}
	else{
		window.open(sUrl);
	}
}
function yahooToggleIconsAndNames() {
	try {
		var toolbar = document.getElementById("yahoo-toolbar-btns");
		var more = document.getElementById("yahoo-toolbar-more-menu");
		var context = document.getElementById("yahoo-toolbar-cm-sio");
		if(more != null){
			more = more.firstChild;
		}
		var menus = [toolbar, more];
		if(toolbar == null){
			return;
		}
		if(yahooGetPref("yahoo.options.iconsonly") == true) {
			yahooParamNOTEXT = "TRUE";
			toolbar.className = "yahoo-button-hidelabels";
		} 
		else{
			yahooParamNOTEXT = "FALSE";
			toolbar.className = "";
		}
		if(context != null){
			context.setAttribute("checked", yahooParamNOTEXT.toLowerCase());
		}
		yahooToolbarOverflowDelay();
	} catch(e) {
	}
}
